#include<iostream>
#include<string>
#include<fstream>
#include<sstream>
#include<vector>
using namespace std;

class Read{
public:
Read() : mism(0), chr("0"), strand('+'), pos(0) {};
Read(string ch, char st, long int p, int m) : mism(m), chr(ch), strand(st), pos(p) {};
string chr;
char strand;
long int pos;
int mism;
};

void parse_options(int argc, char* argv[], string &inp_pos, string &outp, string &totals, 
	string &pos_thresh)
{
	int res = 0;

	long int i, j;
	for(i = 1; i < argc; i++){
		if(argv[i][0] != '-'){
			cerr << "ERROR: Invalid char=" << argv[i][1] << "=this" << endl; 
			exit(0); 
			return ;
		}
		switch(argv[i][1]){
		case 'r': outp = argv[++i]; break;//output of brat-bw
		case 'p': inp_pos = argv[++i]; break;//original positions
		case 't': totals = argv[++i]; break;//total reads attempted to map
		case 'e': pos_thresh = argv[++i]; break;//threshold for position to be considered correct
		default: cerr << "ERROR: Invalid char=" << argv[i][1] << "=this" << endl; exit(0); break;
		}
	}//for i

	return ;
}//parse_opt()

int main(int argc, char* argv[]){
	string inp ;//file with correct positions: read_id, read, chr, strand, pos, mism, indel_len, indel_pos
	string inp2 ;//output of brat-bw
	string totals ;//total reads attempted to ma
	string thresh_pos ;

	parse_options(argc, argv, inp, inp2, totals, thresh_pos);
	long int thresh = 50;
	if(!thresh_pos.empty()){
		istringstream istr_pos(thresh_pos);
		istr_pos >> thresh ;
	}
	

	long int total = 100;
	if(totals.empty()){
		cout << "ERROR: please provide the total number of reads attempted to map (option t)" << endl;
		exit(0);
	}
	else{
		istringstream istr(totals);
		istr >> total;
	}
	ifstream in;
	in.open(inp.c_str(), ios::in);
	
	if(!in){
		cout << "ERROR: please provide file with original positions (option p)" << endl;
		exit(0);
	}
	
	string read, chr;
	char strand;
	long int indel_len, indel_pos, id, st = 0, en = 0, pos, mism, last ;
	vector<Read> reads;//max len 76
	reads.resize(total+2);
	in >> id;	
	while(!in.eof()){
		in >> read >> chr >> strand >> pos >> mism >> indel_len >> indel_pos;
		
		reads[id].chr = chr;
		reads[id].pos = pos;
		reads[id].strand = strand;
		reads[id].mism = mism;
		in >> id;
	
	}//while
	in.close(); in.clear();
	cout << "\n Positions are loaded size = " << reads.size() << endl;

	long int total_pos_good = 0;
	in.open(inp2.c_str(), ios::in);
	if(!in){
		cout << "ERROR: please provide file with BRAT-BW's output (option p)" << endl;
		exit(0);
	}
	long int total_wrong = 0, total_good = 0, wrong_less = 0, wrong_equal = 0, wrong_greater = 0;
	long int wrong_chr = 0, wrong_strand = 0, wrong_pos = 0;
        in >> id;//id starts with 0 and pos starts with 0 
        while(!in.eof()){
                in >> read >> chr >> strand >> pos >> mism >> last;

//if(read.length() == 85){
		id++;
		pos++;
        if(reads[id].chr == chr && reads[id].strand == strand && reads[id].pos == pos)
		{
			total_good++;
			if(strand == '+')
				total_pos_good++;	
		}
		else
		{
			total_wrong++;
			if(reads[id].chr != chr)
			{
				wrong_chr++;

			}//if
			else if(reads[id].strand != strand)
				wrong_strand++;
			else{
			long int less_pos = reads[id].pos - thresh;
			long int greater_pos = reads[id].pos + thresh;
			if(pos >= less_pos && pos <= greater_pos){}
			else 
				wrong_pos++;

		
		}//if greater mism
		}

		in >> id;

        }//while

	cout << "Total of correctly mapped reads = " << total_good << ", of them positive: " 
		<< total_pos_good  << endl;

	long int total_reads = total_good + total_wrong;
	long int total_correct2 = total_reads - (wrong_chr + wrong_strand + wrong_pos);
	long int total_wrong2 = wrong_chr + wrong_strand + wrong_pos;

	double map_acc2 = (0.0 + total_correct2)/(0.0 + total_reads);

	cout << "Mapping accuracy = " << (100.0 * map_acc2) << endl; 
}
